org.eclipse.ui.commands

## Interface ICommandImageService

All Superinterfaces:
  IDisposable

    public interface ICommandImageService
    extends IDisposable

Provides a look-up facility for images associated with commands.

The type of an image indicates the state of the associated command within the user interface. The supported types are: `TYPE_DEFAULT` (to be used for an enabled command), `TYPE_DISABLED` (to be used for a disabled command) and `TYPE_HOVER` (to be used for an enabled command over which the mouse is hovering).

The style of an image is an arbitrary string used to distinguish between sets of images associated with a command. For example, a command may appear in the menus as the default style. However, in the toolbar, the command is simply the default action for a toolbar drop down item. As such, perhaps a different image style is appropriate. The classic case is the "Run Last Launched" command, which appears in the menu and the toolbar, but with different icons in each location.

We currently support a default image style (none) and an image style of IMAGE_STYLE_TOOLBAR.

Since:
  3.4
Restriction:
  This interface is not intended to be implemented by clients.
Restriction:
  This interface is not intended to be extended by clients.

### Field Summary

Fields
`static String` `IMAGE_STYLE_DEFAULT` The default image style.
`static String` `IMAGE_STYLE_TOOLBAR` The image style used for commands in a toolbar.
`static int` `TYPE_DEFAULT` The type of image to display in the default case.
`static int` `TYPE_DISABLED` The type of image to display if the corresponding command is disabled.
`static int` `TYPE_HOVER` The type of image to display if the mouse is hovering over the command and the command is enabled.

### Method Summary

All Methods Instance Methods Abstract Methods
`ImageDescriptor` `getImageDescriptor(String commandId)` Retrieves the default image associated with the given command in the default style.
`ImageDescriptor` `getImageDescriptor(String commandId, int type)` Retrieves the image of the given type associated with the given command in the default style.
`ImageDescriptor` `getImageDescriptor(String commandId, int type, String style)` Retrieves the image of the given type associated with the given command in the given style.
`ImageDescriptor` `getImageDescriptor(String commandId, String style)` Retrieves the default image associated with the given command in the given style.

### Methods inherited from interface org.eclipse.ui.services.IDisposable

`dispose`

### Field Detail

#### TYPE_DEFAULT

    static final int TYPE_DEFAULT

The type of image to display in the default case.

See Also:
  Constant Field Values

#### TYPE_DISABLED

    static final int TYPE_DISABLED

The type of image to display if the corresponding command is disabled.

See Also:
  Constant Field Values

#### TYPE_HOVER

    static final int TYPE_HOVER

The type of image to display if the mouse is hovering over the command and the command is enabled.

See Also:
  Constant Field Values

#### IMAGE_STYLE_DEFAULT

    static final String IMAGE_STYLE_DEFAULT

The default image style. This is provided when no style is requested or when the requested style is unavailable. (Value is null)

#### IMAGE_STYLE_TOOLBAR

    static final String IMAGE_STYLE_TOOLBAR

The image style used for commands in a toolbar. This is useful if you want the icon for the command in the toolbar to be different than the one that is displayed with menu items. (Value is toolbar)

See Also:
  Constant Field Values

### Method Detail

#### getImageDescriptor

    ImageDescriptor getImageDescriptor(String commandId)

Retrieves the default image associated with the given command in the default style.

Parameters:
  `commandId` - The identifier to find; must not be `null`.
Returns:
  An image appropriate for the given command; may be `null`.

#### getImageDescriptor

    ImageDescriptor getImageDescriptor(String commandId,
                                       int type)

Retrieves the image of the given type associated with the given command in the default style.

Parameters:
  `commandId` - The identifier to find; must not be `null`.
  `type` - The type of image to retrieve. This value must be one of the `TYPE` constants defined in this interface.
Returns:
  An image appropriate for the given command; `null` if the given image type cannot be found.

#### getImageDescriptor

    ImageDescriptor getImageDescriptor(String commandId,
                                       int type,
                                       String style)

Retrieves the image of the given type associated with the given command in the given style.

Parameters:
  `commandId` - The identifier to find; must not be `null`.
  `type` - The type of image to retrieve. This value must be one of the `TYPE` constants defined in this interface.
  `style` - The style of the image to retrieve; may be `null`.
Returns:
  An image appropriate for the given command; `null` if the given image style and type cannot be found.

#### getImageDescriptor

    ImageDescriptor getImageDescriptor(String commandId,
                                       String style)

Retrieves the default image associated with the given command in the given style.

Parameters:
  `commandId` - The identifier to find; must not be `null`.
  `style` - The style of the image to retrieve; may be `null`.
Returns:
  An image appropriate for the given command; `null` if the given image style cannot be found.